var _ = require('underscore');

var diff = function(l1, l2, options){
	if (!_.isArray(l1) || !_.isArray(l2)){
		throw "the first two arguments must be arrays";
	}
	var ignoreFields = [];
	if (options && options.ignoreFields){
		ignoreFields = options.ignoreFields;	
	}
	var i1 = _.keys(l1);
	var i2 = _.keys(l2);
	var scratch1 = _.clone(l1);
	var scratch2 = _.clone(l2);
	scratch1 = _.map(scratch1, function(row){
		return removeFieldsAndJsonify(row, ignoreFields);
	});
	scratch2 = _.map(scratch2, function(row){
		return removeFieldsAndJsonify(row, ignoreFields);
	});

	var max = Math.max(l1.length, l2.length);
	var result = [];
	while (i1.length || i2.length){
		if (i1.length === 0){
			var l2index = i2.shift();
			result.push({ change : 'list2', row : l2[l2index]});			
			continue;
		}
		if (i2.length === 0){
			result.push({ change : 'list1', row : l1[i1.shift()]});			
			continue;
		}
    var newRow;
    if (i1.length < i2.length){
      newRow = l2[i2.shift()]; 
      var s1index = scratch1.indexOf(scratch2.shift());
      if ( s1index !== -1){
        result.push({ change : false, row : newRow});
        scratch1.splice(s1index, 1);			
        i1.splice(s1index, 1);			
      } else {
        result.push( { change : 'list2', row : newRow });
      }
    } else {
      newRow = l1[i1.shift()]; 
      var s2index = scratch2.indexOf(scratch1.shift());
      if ( s2index !== -1){
        result.push({ change : false, row : newRow});
        scratch2.splice(s2index, 1);			
        i2.splice(s2index, 1);			
      } else {
        result.push( { change : 'list1', row : newRow });
      }

    }
	}

	return result;
};

module.exports = diff;

function removeFieldsAndJsonify(obj, fields){
	_.each(fields, function(field){
		delete obj[field];
	});
	return JSON.stringify(obj);
}
